<?php


/**
 * This class adds structure of 'katao_product' table to 'propel' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    lib.model.map
 */
class KataoProductMapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'lib.model.map.KataoProductMapBuilder';

	/**
	 * The database map.
	 */
	private $dbMap;

	/**
	 * Tells us if this DatabaseMapBuilder is built so that we
	 * don't have to re-build it every time.
	 *
	 * @return     boolean true if this DatabaseMapBuilder is built, false otherwise.
	 */
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	/**
	 * Gets the databasemap this map builder built.
	 *
	 * @return     the databasemap
	 */
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	/**
	 * The doBuild() method builds the DatabaseMap
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('katao_product');
		$tMap->setPhpName('KataoProduct');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('REFERENCE', 'Reference', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('NAME', 'Name', 'string', CreoleTypes::VARCHAR, true, 255);

		$tMap->addColumn('URL_IDENTIFIER', 'UrlIdentifier', 'string', CreoleTypes::VARCHAR, true, 255);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::LONGVARCHAR, false, null);

		$tMap->addForeignKey('KATAO_PRODUCT_FAMILY_ID', 'KataoProductFamilyId', 'int', CreoleTypes::INTEGER, 'katao_product_family', 'ID', true, null);

		$tMap->addForeignKey('KATAO_SUPPLIER_ID', 'KataoSupplierId', 'int', CreoleTypes::INTEGER, 'katao_supplier', 'ID', true, null);

		$tMap->addColumn('MAX_SOL_AMOUNT', 'MaxSolAmount', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('UNIT_PRICE_EURO', 'UnitPriceEuro', 'double', CreoleTypes::FLOAT, true, null);

		$tMap->addColumn('MARGIN', 'Margin', 'double', CreoleTypes::FLOAT, false, null);

		$tMap->addColumn('TVA_RATE', 'TvaRate', 'double', CreoleTypes::FLOAT, false, null);

		$tMap->addColumn('MIN_ORDER_NUMBER', 'MinOrderNumber', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('PICTURE', 'Picture', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('DELIVERY_DELAY', 'DeliveryDelay', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('IS_ARCHIVED', 'IsArchived', 'int', CreoleTypes::INTEGER, false, 1);

		$tMap->addColumn('ACCOUNTING_CODE_PURCHASE', 'AccountingCodePurchase', 'string', CreoleTypes::VARCHAR, true, 12);

		$tMap->addColumn('ACCOUNTING_CODE_SELL', 'AccountingCodeSell', 'string', CreoleTypes::VARCHAR, true, 12);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'int', CreoleTypes::TIMESTAMP, false, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'int', CreoleTypes::TIMESTAMP, false, null);

	} // doBuild()

} // KataoProductMapBuilder
